import { SubscribeMessage, WebSocketGateway, WebSocketServer } from '@nestjs/websockets'
import { Server, Socket } from 'socket.io'

@WebSocketGateway({
  cors: { allowedHeaders: process.env.API_HOSTNAME },
})
export class GeolocationsGateway {
  @WebSocketServer()
  server: Server

  @SubscribeMessage('last-location')
  handleLastLocation(client: Socket, payload: any) {
    return this.server.emit('last-location', payload)
  }
}
